import java.io.*;
import java.lang.*;
import java.net.*;
import java.math.BigInteger;

public class VerServer
{
    public static void main(String args[]) throws IOException
    {
        String VerPrivate = "359863963204303";
        String Vern = "38491435472850277";
        String TabVerPublic = "23153449029526889";
        String TabVern = "36460515009807947";
    
        //The BigInteger values of Keys
        BigInteger TVPK = BigInteger.valueOf(Long.parseLong(TabVerPublic));
        BigInteger TVn = BigInteger.valueOf(Long.parseLong(TabVern));
        BigInteger VerPrivateKey = BigInteger.valueOf(Long.parseLong(VerPrivate));
        BigInteger VernKey = BigInteger.valueOf(Long.parseLong(Vern));
        
        //Incoming Keys
        String ClientPublic = "";
        String Clientn = "";
        BigInteger ClientPublicKey,ClientnKey;
    
        //Incoming Messages
        String Encrypted = "";
        String text = "";
        String SignedMessage = "";
    
        String Message = "";
        int serverport = 3000;
        ServerSocket s = new ServerSocket(serverport);
        ServerSocket RegAskServer = new ServerSocket(3001);
        System.out.println("Verification Server started at port " + serverport);
        
        RSACrypt Cry = new RSACrypt();
        RSADecrypt d = new RSADecrypt();

        while(true)
        {
            Socket clientConn = s.accept();
            InputStream in = clientConn.getInputStream();
            DataInputStream din = new DataInputStream(in);
            text = din.readUTF();
            SignedMessage = d.Decrypt(text, VerPrivateKey, VernKey);
        
            int KeyNumber = 1;
            int j = 0;
            for(int i=0;i<SignedMessage.length();i++)
            {
                if((SignedMessage.charAt(i) == ':') && (KeyNumber == 1))
                {
                    Encrypted = SignedMessage.substring(0,i);
                    j = i+1;
                    KeyNumber += 1;
                }
                else if((SignedMessage.charAt(i) == ':') && (KeyNumber == 2))
                {
                    ClientPublic = SignedMessage.substring(j, i);
                    j = i+1;
                    Clientn = SignedMessage.substring(j, SignedMessage.length());
                    break;
                }
            }
            //Sending client keys to RegServer for Verifying            
            Socket RegAsk = new Socket("127.0.0.1",2000);
            OutputStream RegAskOut = RegAsk.getOutputStream();
            DataOutputStream RegAskDout = new DataOutputStream(RegAskOut);
            String RegkeystoAsk = ClientPublic + ":" + Clientn;
            RegAskDout.writeUTF(RegkeystoAsk);
            RegAsk.close();
           
            //Waiting result from RegServer
            Socket RegConn = RegAskServer.accept();
            InputStream RegAskRes = RegConn.getInputStream();
            DataInputStream RegAskResDin = new DataInputStream(RegAskRes);
            int Verifiable = RegAskResDin.readInt();

            //Getting BigIntegerKeys
            ClientPublicKey = BigInteger.valueOf(Long.parseLong(ClientPublic));        
            ClientnKey = BigInteger.valueOf(Long.parseLong(Clientn));

            //Decrypting the message
            String VoteMessage = d.Decrypt(Encrypted, ClientPublicKey, ClientnKey);
            
            //Crypting the verified message
            String VerMes = Cry.Crypt(Cry.Crypt(Cry.Crypt(VoteMessage, TVPK, TVn) + Verifiable, VerPrivateKey, VernKey), ClientPublicKey, ClientnKey);

            //Sending verified message
            Socket Cl = new Socket("127.0.0.1",3002);
            OutputStream x = Cl.getOutputStream();
            DataOutputStream ClDout = new DataOutputStream(x);
            ClDout.writeUTF(VerMes);
            Cl.close();
        }
    }
}