import java.io.*;
import java.lang.*;
import java.net.*;

public class RegServer
{
    int Counter = 0;
    String [][] Table = new String[100][5];
    
    String ClientPublic = "";
    String Clientn = "";
    
    private int VerifyId(String text)
    {
        int X=0;
        for(int i=0;i<Counter;i++)
            if(text.equals(Table[i][2]))
                X = 1;
        return X;
    }

    private void Parser(String keys)
    {
        for(int i=0;i<keys.length();i++)
            if(keys.charAt(i) == ':')
            {
                ClientPublic = keys.substring(0, i);
                Clientn = keys.substring(i+1, keys.length());
                break;
            }
    }
    
    private void KeyWriter(String Public,String n,String ID,String Private)
    {
        Table[Counter][0] = Public;
        Table[Counter][1] = n;
        Table[Counter][2] = ID;
        Table[Counter][3] = Private;
        Table[Counter][4] = "0";
        Counter += 1;
    }
    
    private int KeyVerifier(String keys)
    {
        int X = 0;
        Parser(keys);
        for(int i=0;i<Counter;i++)
           if((ClientPublic.equals(Table[i][0])) && (Clientn.equals(Table[i][1])) 
           && Table[i][4].equals("0"))
           {
              X = 1;
              Table[i][4] = "1";
              break;
           }
        return X;
    }
    
    public static void main(String args[]) throws IOException
    {
        RegServer obj = new RegServer();
        
        String Vern = "38491435472850277";
        String VerPublic = "12438421318541467";
        String Tabn = "48229967951050157";
        String TabPublic = "12900267038726177";

        String Message = "";
        String res ="";
        int serverport = 2000;
        ServerSocket s = new ServerSocket(serverport);
        System.out.println("Registration Server started at port " + serverport);

        while(true)
        {
            //Accepting all messages
            Socket clientConn = s.accept();
            InputStream in = clientConn.getInputStream();
            DataInputStream din = new DataInputStream(in);
            Message = din.readUTF();
            //Message taken, parsing the message
            
            //Eger clien'dan geldiyse burada isleme konulacak
            if(Message.substring(0,6).equals("client"))
            {
                //Eger yeni basvuru yapiliyorsa buraya girecek
                if(0 == obj.VerifyId(Message.substring(7,Message.length())))
                {
                    RSAKeyGenerator KeyGen = new RSAKeyGenerator();
                    KeyGen.Generate();
                    obj.KeyWriter(String.valueOf(KeyGen.e),String.valueOf(KeyGen.n),
                    Message.substring(7,Message.length()),String.valueOf(KeyGen.d));
                    res = KeyGen.n + ":" + KeyGen.e + ":" + KeyGen.d + ":" + 
                    Vern + ":" + VerPublic + ":" + Tabn + ":" + TabPublic;
                }
                //Eger gecersiz oysa burasi isleme konulacak
                else
                {
                    for(int i=0;i<obj.Counter;i++)
                        if(Message.substring(7,Message.length()) == obj.Table[i][2])
                            res = obj.Table[i][1] + ":" + obj.Table[i][0] + ":" + 
                            obj.Table[i][3] + ":" +  Vern + ":" + VerPublic + ":" + 
                            Tabn + ":" + TabPublic;
                }

                //Buradan sonra client'a keyler gonderiliyor
                Socket Cl = new Socket("127.0.0.1",2001);
                OutputStream x = Cl.getOutputStream();
                DataOutputStream ClDout = new DataOutputStream(x);
                ClDout.writeUTF(res);
                Cl.close();
            }
            //Eger VerServer'dan geldiyse buraya girecek
            else
            {
                //Keylerin verify edilmesi
                int V = obj.KeyVerifier(Message);
                
                //Buradan sonra VerServer'a sonuc gonderiliyor
                Socket Versend = new Socket("127.0.0.1",3001);
                OutputStream x = Versend.getOutputStream();
                DataOutputStream VersendDout = new DataOutputStream(x);
                VersendDout.writeInt(V);
                Versend.close();
            }
        }
    }
}