import java.io.*;
import java.lang.*;
import java.net.*;
import java.math.BigInteger;

public class TabServer
{
    public static void main(String args[]) throws IOException
    {
        String TabPrivate = "405497689069217";
        String Tabn = "48229967951050157";
        String TabVerPrivate = "48801208697";
        String TabVern = "36460515009807947";
        
        BigInteger TVPrK = BigInteger.valueOf(Long.parseLong(TabVerPrivate));
        BigInteger TVn = BigInteger.valueOf(Long.parseLong(TabVern));
        BigInteger TabPrivateKey = BigInteger.valueOf(Long.parseLong(TabPrivate));
        BigInteger TabnKey = BigInteger.valueOf(Long.parseLong(Tabn));
        
        String Encrypted = "";
        
        String ClientPublic = "";
        String Clientn = "";
        BigInteger ClientPublicKey,ClientnKey;
        
        int NumberofQuestions = 3;
        int Counter = 0;
        int [] Votes = new int[NumberofQuestions];
        String Message = "";
        
        System.out.println("Enter the number of voters");
        DataInputStream VotersInput = new DataInputStream(System.in);
        String NumberofVotersString = VotersInput.readLine();
        int NumberofVoters = Integer.parseInt(NumberofVotersString);
        
        int serverport = 4000;
        ServerSocket s = new ServerSocket(serverport);
        System.out.println("Tabulation Server started at port " + serverport);
 
        RSADecrypt Decry = new RSADecrypt();

        while(true)
        {
            Counter += 1;
            Socket clientConn = s.accept();
            InputStream in = clientConn.getInputStream();
            DataInputStream din = new DataInputStream(in);
            Message = din.readUTF();
            
            String SignedMessage = Decry.Decrypt(Message, TabPrivateKey, TabnKey);

            int KeyNumber = 1;
            int j = 0;
            for(int i=0;i<SignedMessage.length();i++)
            {
                if((SignedMessage.charAt(i) == ':') && (KeyNumber == 1))
                {
                    Encrypted = SignedMessage.substring(0,i);
                    j = i+1;
                    KeyNumber += 1;
                }
                else if((SignedMessage.charAt(i) == ':') && (KeyNumber == 2))
                {
                    ClientPublic = SignedMessage.substring(j, i);
                    j = i+1;
                    Clientn = SignedMessage.substring(j, SignedMessage.length());
                    break;
                }
            }
            
            //Getting BigIntegerKeys
            ClientPublicKey = BigInteger.valueOf(Long.parseLong(ClientPublic));        
            ClientnKey = BigInteger.valueOf(Long.parseLong(Clientn));
            
            String RealMessage = Decry.Decrypt(Decry.Decrypt(Encrypted, ClientPublicKey, ClientnKey), TVPrK, TVn);
            
            System.out.println("The Message is : " + RealMessage + "\n");
            for(int i=0;i<NumberofQuestions;i++)
                Votes[i] += Integer.parseInt(RealMessage.substring(i,i+1));
            if(Counter == NumberofVoters)
                break;
        }
        System.out.println("Oylarin Sonucu : \n");
        for(int i=1;i<=NumberofQuestions;i++)
            System.out.println(i + ". soru : " + (float)Votes[i-1]/Counter + "\n");
    }
}