import java.io.*;
import java.net.*;

class browser {
	public static void main (String args[]) {
		if (args.length != 1 && args.length != 2)
		{
			System.out.println("Usage : \t");
			System.out.println("java browser yourURL [fileName] \t");
                        System.exit(1);
		}
		try
		{
			InetAddress addr = InetAddress.getByName(args[0]);
			Socket sock = new Socket(addr,80);
			String requestCommand;
			if (args.length == 1)
				requestCommand = "GET /index.html HTTP/0.9 \r\n\r\n";
			else
				requestCommand = "GET /"+args[1]+" HTTP/0.9 \r\n\r\n";
			DataInputStream dInS = new DataInputStream(sock.getInputStream());
			DataOutputStream dOutS = new DataOutputStream(sock.getOutputStream());
			dOutS.writeBytes(requestCommand);
			
			String replyLine;
			boolean smallSign = false;
			int lineCount = 0;
			while ((replyLine = dInS.readLine()) != null)           
			{
				if (lineCount > 24)
				{	
					System.out.println("Press enter to Continue ");
					System.in.read();
					lineCount = 0;
				}
				// Display each line to the console
				String output;
				int var = replyLine.indexOf('<'); 
				if (var != -1)
				{
					output = "";
		
					int index = 0;
					char ch,prevCh = '>';	
					while(index < replyLine.length())
					{
						int wroteCharCount = 0;
						ch = replyLine.charAt(index);
						
						if(ch == '<')
						   smallSign = true;
						if(ch == '>')
						   smallSign = false;
						else
							if (smallSign == false)
							{	if (prevCh != '\n'  || ch != '\n')
								{
									output+= ch;		
									prevCh = ch;
									wroteCharCount++;					
									if (ch == '\n' || wroteCharCount>80)
									{
										lineCount++;
										wroteCharCount = 0;
									}
								}
							}
						index++;
					}
					
					System.out.print(output);

				}
                		if ( replyLine.indexOf("</HTML>") != -1 )
                    		break;
			}
		
			sock.close();
		}
		catch(IOException e)
		{
			System.out.println("\nIO exception ");
			System.exit(1);
		}
	}
}


